Subject: [Roll] Some confusions in RFC 6719 (MRHOF)

From: Duong Ngoc Nguyen <[email-masked]>
Date: Wed, 7 Nov 2012 14:55:18 -0500 (EST)

As I work with MRHOF, I find some statements are not consistent that I cannot resolve by myself. I'm very grateful if someone can help me overcome this confusion.

1. Which path cost is carried in Metric Container?

Section 3.2.2 states:

   Once the preferred parent is selected, the node sets its
   cur_min_path_cost variable to the path cost corresponding to the
   preferred parent.  The value of the cur_min_path_cost is carried in
   the Metric Container corresponding to the selected metric when DIO
   messages are sent.

==> it suggests Metric Container carries the cost through the best (i.e. preferred) parent.

While section 3.4 states:

   Once the preferred parent is selected, the node sets its
   cur_min_path_cost variable to the path cost corresponding to its
   preferred parent.  It then calculates the metric it will advertise in
   its metric container.  This value is the path cost of the member of
   the parent set with the highest path cost.  Thus, while
   cur_min_path_cost is the cost through the preferred parent, a node
   advertises the highest cost path from the node to the root through a
   member of the parent set.  The value of the highest cost path is
   carried in the metric container corresponding to the selected metric
   when DIO messages are sent.

==> it suggests Metric Container carries the cost through the worst parent.

2. Which value is written to Rank field of DIO messsage's base object in case ETX is used?

When ETX is the metric, node must not include Metric container, thus the rank field in DIO's base object is the only information to advertise to neighbors.

Section 3.4 states:

   If ETX is the selected metric, a node MUST NOT advertise it in a
   metric container.  Instead, a node MUST advertise an approximation of
   its ETX in its advertised Rank value, following the rules described
   in Section 3.3...

==> The phrase "in its advertised Rank value, following the rules described in Section 3.3." means we would write the value of node rank (computed by rules in section 3.3) into the rank field of DIO message.

On the other hand, section 3.5 states:

   ... Once parent selection and rank computation is performed
   using the ETX metric, the node advertises the Rank and MUST NOT
   include a metric container in its DIO messages.  While assigning Rank
   in this case, use the representation of ETX described in [RFC6551],
   i.e., assign Rank equal to ETX * 128.

==> The phrase "assign Rank equal to ETX * 128" suggests that we should write value of ETX of path cost to the rank field of DIO message.

3. A possible typo.
Section 3.5 states:

   In the absence of a Metric Container, MRHOF uses ETX as its metric.
   It locally computes the ETX of links to its neighbors and adds this
   value to their advertised Rank to compute the associated Rank of
   routes...

==> Adding ETX of link and value of advertised rank is to compute cost of a route, not rank of a route. Rank of a route is computed by adding MinHopRankIncrease (instead of link's ETX) with advertised rank (as in section 3.3)

Sincerely thanks,
Duong Nguyen

---

From: Philip Levis <[email-masked]>
Date: Wed, 28 Nov 2012 13:27:25 -0800

Phil

> ==> it suggests Metric Container carries the cost through the worst parent.

3.4 is correct.

> ==> The phrase "assign Rank equal to ETX * 128" suggests that we should write value of ETX of path cost to the rank field of DIO message.

3.4 is correct. The term "assign" is meant to describe the transformation between ETX and rank values, not the Rank in the DIO.

Phil

---

From: Duong Ngoc Nguyen <[email-masked]>
Date: Thu, 29 Nov 2012 08:45:14 -0500 (EST)

Thanks.

Sincerely,
Duong Nguyen

----- Original Message -----
> From: "Philip Levis" <[email-masked]>
> To: "Duong Ngoc Nguyen" <[email-masked]>
> Cc: [email-masked]
> Sent: Wednesday, November 28, 2012 4:27:25 PM
> Subject: Re: [Roll] Some confusions in RFC 6719 (MRHOF)
> Phil
> 
> > As I work with MRHOF, I find some statements are not consistent that
> > I cannot resolve by myself. I'm very grateful if someone can help me
> > overcome this confusion.
> >
> > When ETX is the metric, node must not include Metric container, thus
> > the rank field in DIO's base object is the only information to
> > advertise to neighbors.
> >
> > Section 3.4 states:
> >
> > ==> The phrase "in its advertised Rank value, following the rules
> > described in Section 3.3." means we would write the value of node
> > rank (computed by rules in section 3.3) into the rank field of DIO
> > message.
> >
> > ==> The phrase "assign Rank equal to ETX * 128" suggests that we
> > should write value of ETX of path cost to the rank field of DIO
> > message.
> >
> 
> 3.4 is correct. The term "assign" is meant to describe the
> transformation between ETX and rank values, not the Rank in the DIO.
> 
> Phil